var redis = require('redis');
var ip;

function createClient(){
  var client = redis.createClient(null, ip, null);
  client.select(3, function(){
  });
  return client;
}

function boot(redisip, handler){
  ip = redisip;
  var pubclient = redis.createClient(null, redisip, null);
  pubclient.select(3, function(){});
  
  var subclient = redis.createClient(null, redisip, null);
  subclient.select(3, function(){
    console.log('listening to database3');});
  
  var listen = function(){ 
    subclient.brpoplpush( "eventQueue",  "workQueue","0", function (err,  evt){
      var event = null; 
      try{ 
        event = JSON.parse(evt); 
      }catch(e){
        console.log('error parsing event');
        //Log err
      }
      if(err){
        //Log err
      }else if(event){
        handler.emit('event::new', event);
      }else{
        //Log err
      }
      listen();
    });
  }
  listen();

  handler.on('event::complete', function(evt){
    pubclient.lrem(["workQueue", "-1", JSON.stringify(evt)],function(err, reply){
      console.log('removed ' + evt.id + ' from workQueue');
    });
  });
  handler.on('event::old', function(evt){
    pubclient.lrem(["workQueue", "-1", JSON.stringify(evt)],function(err, reply){
      console.log('removed old event' + evt.id + ' from workQueue');
    });
  });
}

module.exports.createClient = createClient;
module.exports.boot = boot;
