var mongoose = require('mongoose');
var Rule = mongoose.model('Rule');


exports.getRules = function(event, cb){
  console.log('getting rules');
  console.log(event);
  if(event.type === 'sensor'){
    var search = {sensorId: event.evt._id, user: event.evt.user, enabled: true};
    var eventData = event.evt.lastReading;
  }else if(event.type === 'hook'){
    var search = {hookId: event.evt._id, user: event.evt.user, enabled: true};
    var eventData = event.evt.data;
  }else{
    return cb(null);
  }
  //xx Use FindOne for now, later we will examine multiple rules per sensor/hook later
  // Using find() temporarily..
  Rule.find(search).exec(function(err, rules){
    console.log(rules); 
    console.log('search results above'); 
    if(err) return cb(err, null, null);
    if(!rules || rules.length === 0)
      return cb(null, null, null);
    else
      return cb(null, rules.map(function(item) {return item.rule;}), eventData);
  });
}

function getHookRule(hookId){
  if(hookDb[hookId]){
    console.log(hookId);
    return hookDb[hookId];
  }else{
    return null;
  }
}
var hookDb = {
  '5126512f33195a0a7a000001':
    {
      ifs: [
        { operands: [ {'_value': 1} ,{'_value': 1}],
          test: '==',
        }
      ],
      then:
        {
          _catalog: { name: 'displayCommit',
                    args: [ '_object.repo','_object.commit']}
        }
    }
}


function getSensorRule(sensorId){
  if(sensorDb[sensorId]){
    console.log(sensorId);
    return sensorDb[sensorId];
  }else{
    return null;
  }
}

var sensorDb = {
  '512660d6b1cd498e49000004':
    {
      ifs: [
        { operands: [ '_object.mode', {'_value': 0}],
          test: '==',
        }
      ],
      then:
        {
          _catalog :{ name: 'toggleThermostat',
                    args: [ {'_value': '51266039b1cd498e49000002'}]}
        }
    },
  '51266039b1cd498e49000002':
    {
      ifs: [
        { operands: [ {'_value': 0}, {'_value': 0}],
          test: '===',
        }
      ],
      then:
        {
          _catalog: { name: 'displayTemp',
                    args: [ '_object.currentTemp', '_object.relay1']}
        }
    }
}

