var mongoose = require('mongoose')
, Schema = mongoose.Schema;

var HookSchema = new Schema({
  provider : {type: String},
  providerId: {type: String},
  user : {type: Schema.ObjectId, ref: 'User'},
  createAt: {type:Date, default: Date.now},
  data: {type: Schema.Types.Mixed},
  lookupId: {type:String},
  key: {type: Schema.Types.Mixed}
});

HookSchema.pre('save', function(next){
  this.lookupId = this.provider + '-' + this.providerId;
  next();
});

HookSchema.index({lookupId: 1});
mongoose.model('Hook', HookSchema);



