var env = process.env.NODE_ENV || 'development',
    config = require('./config/config')[env],
    EventEmitter = require('eventemitter2').EventEmitter2,
    handler = new EventEmitter({delimiter : '::', wildcard: true}),
    fs = require('fs');

var mongoose = require('mongoose'),
    Schema = mongoose.Schema;

mongoose.connect(config.db);

var models_path = __dirname + '/models',
    model_files = fs.readdirSync(models_path);

model_files.forEach( function(file) {
    require(models_path + '/' + file);
});

require('./lib/event_queue_agent.js').boot(config.memory, handler);
require('./lib/rulesEngine.js').boot(handler);

